Public Member Functions
CFloatArray Class Reference

## Detailed Description

The CFloatArray is an uni-dimensional array of floats.

The array is zero-based, which means that the first item index is 0 and the larger index is one less than the number of elements contained in the array.

Items are added with CFloatArray::Add. You can also use CFloatArray::Attach to encapsulate an external array. When an array is attached, its items are accessible through the CFloatArray API.

Since:
  5.0

`#include <xsi_floatarray.h>`

List of all members.

## Public Member Functions
| CFloatArray (LONG in_size=0)
| CFloatArray (const CFloatArray &in_array)
| ~CFloatArray ()
CFloatArray & | operator= (const CFloatArray &in_array)
CFloatArray & | operator+= (const CFloatArray &in_array)
CFloatArray & | operator-= (const CFloatArray &in_array)
LONG | GetCount () const
CStatus | Attach (float *in_pArray, LONG in_nSize)
CStatus | Add (const float &in_item)
CStatus | Clear ()
CStatus | Resize (LONG in_size)
CStatus | Resize (LONG in_size, bool in_bReset)
const float & | operator[] (LONG in_index) const
float & | operator[] (LONG in_index)
bool | operator== (const CFloatArray &in_array) const
bool | operator!= (const CFloatArray &in_array) const
CString | GetAsText () const
const float * | GetArray () const
CStatus | Append (const CFloatArray &in_array)

## Constructor & Destructor Documentation

CFloatArray | ( | LONG | in_size = `0` | ) |

Constructs a CFloatArray and optionally initializes the array to a known size.

Parameters:

  in_size | Size of array, defaults to 0.

CFloatArray | ( | const CFloatArray & | in_array | ) |

Constructs a CFloatArray object from another CFloatArray object.

Parameters:

  in_array | constant CFloatArray object.

~CFloatArray | ( |  | ) |

Default destructor.

## Member Function Documentation

CFloatArray& operator= | ( | const CFloatArray & | in_array | ) |

Assignment operator.

Parameters:

  in_array | constant class object.

Returns:
  A reference to this array.

CFloatArray& operator+= | ( | const CFloatArray & | in_array | ) |

Adds the value of each element of `in_array` to the value of the corresponding element of this CFloatArray. The result is stored in this CFloatArray object.

Parameters:

  in_array | A constant CFloatArray object.

Returns:
  A reference to this array.

Since:
  5.1

CFloatArray& operator-= | ( | const CFloatArray & | in_array | ) |

Subtracts the value of each element of `in_array` from the value of the corresponding element of this CFloatArray. The result is stored in this CFloatArray object.

Parameters:

  in_array | A constant CFloatArray object.

Returns:
  A reference to this array.

Since:
  5.1

LONG GetCount | ( |  | ) | const

Returns the number of items in this CFloatArray

Returns:
  The number of items in the array.

CStatus Attach | ( | float * | in_pArray,
|  | LONG | in_nSize
| ) |  |

Encapsulates a pointer to float without taking ownership of it (i.e. the memory is not released when the CFloatArray is deleted). The content of the CFloatArray is erased before attaching the external array. Attach does not take a copy of the external array, however functions like Add and Resize will force a copy of the encapsulated array.

Parameters:

  in_pArray | Array to encapsulate.
  in_nSize | Number of elements in the array.

Returns:
  CStatus::OK success
  CStatus::Fail Operation failed.
  CStatus::InvalidArgument Pointer is null or size is <= 0.

See also:
  CFloatArray::Add, CFloatArray::Resize

Since:
  5.1

CStatus Add | ( | const float & | in_item | ) |

Adds a float at the end of this array.

Parameters:

  in_item | New item to be added at the end of the array.

Note:
  There is a performance cost when calling Add if an external array has been attached with the Attach method: CFloatArray takes a copy of the external array before appending the item.

Returns:
  CStatus::OK success

See also:
  CFloatArray::Attach

CStatus Clear | ( |  | ) |

Erases all elements contained in the array.

Returns:
  CStatus::OK success

CStatus Resize | ( | LONG | in_size | ) |

Reallocates memory for the array, preserves its contents if the new size is larger than existing size.

Note:
  There is a performance cost when calling Resize if an external array has been attached with the Attach method. The method takes a copy of the external array before resizing.

Parameters:

  in_size | New size of the array.

Returns:
  CStatus::OK success
  CStatus::InvalidArgument in_size < 0

See also:
  CFloatArray::Attach

CStatus Resize | ( | LONG | in_size,
|  | bool | in_bReset
| ) |  |

Reallocates memory for the array, preserves its contents if new size is larger than existing size.

Note:
  There is a performance cost when calling Resize if an external array has been attached with the Attach method. The method takes a copy of the external array before resizing.

Parameters:

  in_size | New size of the array.
  in_bReset | Set the array with 0 if true. If false the array is not reset and the content is preserved.

Returns:
  CStatus::OK success
  CStatus::InvalidArgument in_size < 0

See also:
  CFloatArray::Attach

const float& operator[] | ( | LONG | in_index | ) | const

Accessor to elements at a given index. This function can only be called by constant objects, the returned value is read-only.

Parameters:

  in_index | index in this zero-based array.The index must be smaller than the number of elements in the array, otherwise the results are unpredicted.

Returns:
  A read-only reference to the indexed item.

float& operator[] | ( | LONG | in_index | ) |

Accessor to elements at a given index.

Parameters:

  in_index | index in this zero-based array.The index must be smaller than the number of elements in the array, otherwise the results are unpredicted.

Returns:
  A reference to the indexed item.

bool operator== | ( | const CFloatArray & | in_array | ) | const

Equality operator.

Parameters:

  in_array | CFloatArray to compare with.

Returns:
  true if in_array contains the same number of elements as this array and all members of in_array are equal to the corresponding one contained in this array.

bool operator!= | ( | const CFloatArray & | in_array | ) | const

Inequality operator.

Parameters:

  in_array |

Returns:
  true if one member of in_array is different of the corresponding members in this array or if the arrays are not of the same size.

CString GetAsText | ( |  | ) | const

Returns a string that contains the values of this array separated with the comma character.

Returns:
  String of values.

Since:
  5.1

const float* GetArray | ( |  | ) | const

Accessor to the internal array of floats. The array cannot be modified and the content is undefined when the CFloatArray object goes out of scope.

Returns:
  Pointer to an array of floats.

Since:
  5.1

CStatus Append | ( | const CFloatArray & | in_array | ) |

Appends the content of a CFloatArray object to this one.

Parameters:

  in_array | A constant CFloatArray object.

Returns:
  CStatus::OK success
  CStatus::InvalidArgument in_array::GetCount is 0

Since:
  5.1

The documentation for this class was generated from the following file:

- xsi_floatarray.h